//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#include <assert.h>
#include <math.h>
#pragma hdrstop

#include "pgp.h"
#include "PgpPassEx.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpPassForm *PgpPassForm;
//---------------------------------------------------------------------------
bool __fastcall PGPgetSecureModePassphrase(bool &CancelMode, AnsiString &Phrase)
{
   Phrase = "";
   AnsiString s;
   bool success = false;
   TPgpPassForm *pf = new TPgpPassForm(mSecureModePhrase,Application->MainForm);
   if (!CancelMode) pf->ClearModeBtn->Visible = false;
   pf->ShowModal();
   switch (pf->ModalResult)
   {
      case mrOk:
         Phrase = pf->Phrase->Text;
         CancelMode = false;
         success = true;
         break;
      case mrCancel:
         CancelMode = false;
         success = false;
         break;
      case mrAbort:
         CancelMode = true;
         success = false;
         break;
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
bool __fastcall PGPgetDecryptionPassphrase(AnsiString &Phrase)
{
   Phrase = "";
   AnsiString s;
   bool success = false;
   TPgpPassForm *pf = new TPgpPassForm(mDecryptionPhrase,Application->MainForm);
   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      Phrase = pf->Phrase->Text;
      success = true;
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
bool __fastcall PGPgetConventionalPassphrase(AnsiString &Phrase, TForm *MainForm)
{
   Phrase = "";
   AnsiString s;
   bool success = false;
   TPgpPassForm *pf = new TPgpPassForm(mConventionalPhrase,MainForm);
   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      Phrase = pf->Phrase->Text;
      success = true;
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
bool __fastcall PGPgetKeyidAndPassphrase(TStrings *Keys, int &CurrentKey,
   AnsiString &Phrase, TForm *MainForm)
{
   Phrase = "";
   AnsiString s;
   bool success = false;
   TPgpPassForm *pf = new TPgpPassForm(mSignKeyPhrase,MainForm);

   pf->Keyid->Items->Text = Keys->Text;
   if (CurrentKey>=0 && CurrentKey<Keys->Count) pf->Keyid->ItemIndex = CurrentKey;

   TForm *MF = MainForm;
   //TForm *CF = pf;
   pf->Top = MF->Top+((MF->Height-pf->Height)/2);
   pf->Left = MF->Left+((MF->Width-pf->Width)/2);
   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      if (pf->Keyid->ItemIndex>=0)
      {
         CurrentKey = pf->Keyid->ItemIndex;
         Phrase = pf->Phrase->Text;
         success = true;
      }
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
#define NUMRANGES	8
UINT PGPcomdlgPassphraseQuality(LPSTR szPhrase)
{
	UINT quality;
	unsigned short charIndex, rangeIndex, span;
	typedef struct ScoreStruct
	{
		unsigned char firstChar;
		unsigned char lastChar;
	} Range;
	static Range sRanges[] =
	{
		{ 0,		' ' - 1},
		{ ' ',		'A' - 1},
		{ 'A',		'Z'},
		{ 'Z' + 1,	'a' - 1},
		{ 'a',		'z'},
		{ '0',		'9'},
		{ 'z' + 1,	127},
		{ 128,		255},
	};
	BOOL haveRange[NUMRANGES];

  memset(haveRange,'\0',sizeof(haveRange));
//pgpClearMemory (haveRange, sizeof (haveRange));
	for (charIndex = 1; charIndex < lstrlen (szPhrase); ++charIndex) {
		for (rangeIndex = 0; rangeIndex < NUMRANGES; ++rangeIndex)	{
			UCHAR			theChar;
			Range *			theRange;
			
			theChar		= szPhrase[charIndex];
			theRange	= &sRanges[rangeIndex];

			if (theChar >= theRange->firstChar &&
				theChar <= theRange->lastChar)
			{
				haveRange[rangeIndex] = TRUE;
				break;
			}
		}
	}

	// determine the total span
	span = 0;
	for (rangeIndex = 0; rangeIndex < NUMRANGES; ++rangeIndex) {
		if (haveRange[rangeIndex]) {
			span += (unsigned short)(1+(sRanges[rangeIndex].lastChar-
				sRanges[rangeIndex].firstChar));
		}
	}

	if (span != 0) {
		double	bitsPerChar	= log (span) / log (2.0);  // base 2 log of span
		ULONG	totalBits	= (ULONG)(bitsPerChar * lstrlen (szPhrase));

		// assume a maximum quality of 128 bits
		quality = (totalBits * 100) / 128;
		if (quality > 100) quality = 100;
	}
	else {
		quality = 0;
	}

	return (quality);
}
//---------------------------------------------------------------------------
__fastcall TPgpPassForm::TPgpPassForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TPgpPassForm::TPgpPassForm(PassMode Mode, TComponent* Owner)
  : TForm(Owner)
{
   HideTypeBox->Checked = true;
   FormMode = Mode;
   Phrase->Clear();
   Cnfrm->Clear();
   switch (FormMode)
   {
      case mSecureModePhrase:
         Caption = "Secure Mode";
         Label2->Caption = "&Enter passphrase for encryption : ";
         CancelBtn->Visible = OkBtn->Visible = Phrase->Visible = ClearModeBtn->Visible =
            Cnfrm->Visible = Label2->Visible = Label3->Visible = QualityBox->Visible =
            HideTypeBox->Visible = true;
         CancelBtn->Top = OkBtn->Top = ClearModeBtn->Top = 209;
         Label2->Top = HideTypeBox->Top = 66;
         QualityBox->Top = 12;
         Label3->Top = 136;
         Phrase->Top = 85;
         Cnfrm->Top = 152;
         Height = 269;
         ActiveControl = Phrase;
         break;
      case mConventionalPhrase:
         Caption = "Passphrase for Conventional Encryption";
         Label2->Caption = "&Enter passphrase for encryption :";
         CancelBtn->Visible = OkBtn->Visible = Phrase->Visible = Cnfrm->Visible =
            Label2->Visible = Label3->Visible = QualityBox->Visible =
            HideTypeBox->Visible = true;
         Label2->Top = HideTypeBox->Top = 66;
         CancelBtn->Top = OkBtn->Top = 209;
         QualityBox->Top = 12;
         Label3->Top = 136;
         Phrase->Top = 85;
         Cnfrm->Top = 152;
         Height = 269;
         ActiveControl = Phrase;
         break;
      case mSignKeyPhrase:
         Caption = "PGP Signing Passphrase";
         Label2->Caption = "&Enter passphrase for above key :";
         Keyid->Visible = Label2->Visible = Label1->Visible = CancelBtn->Visible =
            OkBtn->Visible = Phrase->Visible = HideTypeBox->Visible = true;
         Label2->Top = HideTypeBox->Top = 62;
         CancelBtn->Top = OkBtn->Top = 135;
         Phrase->Top = 80;
         Label1->Top = 15;
         Keyid->Top = 32;
         Height = 192;
         ActiveControl = Phrase;
         break;
      case mDecryptionPhrase:
         Caption = "PGP Enter Passphrase";
         Label2->Caption = "&Enter passphrase for decryption :";
         CancelBtn->Visible = OkBtn->Visible = Phrase->Visible = Label2->Visible =
            HideTypeBox->Visible = true;
         Label2->Top = HideTypeBox->Top = 8;
         CancelBtn->Top = OkBtn->Top = 84;
         Phrase->Top = 30;
         Height = 141;
         ActiveControl = Phrase;
         break;
   }
   // center form
   TForm *CF = this;
   TForm *MF = (TForm*)Owner;
   if (!MF) Position = poScreenCenter;
   else
   {
      CF->Top = MF->Top+((MF->Height-CF->Height)/2);
      CF->Left = MF->Left+((MF->Width-CF->Width)/2);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      switch (FormMode)
      {
         case mSecureModePhrase:
         case mConventionalPhrase:
            if (Phrase->Text.IsEmpty() && Cnfrm->Text.IsEmpty())
            {
               MessageBox(Handle,"You must enter a passphrase or click on \"Cancel\".","PGP Warning",MB_OK);
               CanClose = false;
            }
            else
            if (Phrase->Text.IsEmpty() || Cnfrm->Text.IsEmpty())
            {
               MessageBox(Handle,"Passphrase entries do not match. Please try again.","PGP Warning",MB_OK);
               CanClose = false;
            }
            break;
         case mSignKeyPhrase:
            if (Phrase->Text.IsEmpty() || Keyid->Text.IsEmpty())
            {
               MessageBox(Handle,"You must enter a passphrase or click on \"Cancel\".","PGP Warning",MB_OK);
               CanClose = false;
            }
            break;
      }
      if (!CanClose) ClearText();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::FormDestroy(TObject *Sender)
{
   ClearText();
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::ClearText()
{
   for (int i=1; i<=Phrase->Text.Length(); i++) Phrase->Text[i] = '\0';
   Phrase->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::PhraseChange(TObject *Sender)
{
   ProgressBar1->Position = (WORD)PGPcomdlgPassphraseQuality(Phrase->Text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::HideTypeBoxClick(TObject *Sender)
{
   Phrase->Font->Color = HideTypeBox->Checked ? clWindow : clBlack;
   Cnfrm->Font->Color = Phrase->Font->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::FormShow(TObject *Sender)
{
   HideTypeBoxClick(0);
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::ClearModeBtnClick(TObject *Sender)
{
   if (MessageBox(Handle,
         "You have asked to remove password encryption from your QS database\n\nAre you sure?",
         "Cancel Secure Mode",MB_YESNO)==IDYES)
   {
      ModalResult = mrAbort;
   }
}
//---------------------------------------------------------------------------
