//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpRecip.h"
#include "Version.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpRecipForm *PgpRecipForm;
//---------------------------------------------------------------------------
bool __fastcall PGPgetEncryptList(TStringList *EncryptList)
{
   TPgpRecipForm *pf = new TPgpRecipForm(Application->MainForm);
   pf->To->Text = EncryptList->Text; EncryptList->Clear();
   CenterDialog(pf,Application->MainForm);
   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      AnsiString s;
      if (pf->Conventional->Checked)
         EncryptList->Text = UseConventional;
      else
      {
         TStrings *list = pf->ListBox2->Items;
         for (int i=0; i<list->Count; i++)
         {
            s = list->Strings[i];
            EncryptList->Add(s.SubString(1,s.Pos("(")-1).TrimRight());
         }
      }
   }
   delete pf;
   return EncryptList->Count>0;
}
//---------------------------------------------------------------------------
__fastcall TPgpRecipForm::TPgpRecipForm(TComponent* Owner)
  : TForm(Owner)
{
   To = new TStringList();
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::LoadPublics()
{
   if (FileExists(HomeVarsText))
   {
      AnsiString s,id;
      ListBox1->Clear();
      TStringList *tmp = new TStringList();
      tmp->LoadFromFile(HomeVarsText);
      int i=0; while ((s=tmp->Values["pk"+AnsiString(++i)])!="")
         ListBox1->Items->Add(s);
      delete tmp;
      ListBox2->Clear();
      // find recipients
      for (int i=0; i<To->Count; i++) // look through list
      {
         s = To->Strings[i]; // get toaddr
         for (int c=0; c<ListBox1->Items->Count; c++) // look through keys
         {
            id = ListBox1->Items->Strings[c]; // get a key
            if (id.Pos(s) && ListBox2->Items->IndexOf(id)<0) // is toaddr substring in key
            {                                   // and key NOT in listbox2
               ListBox2->Items->Add(id);
               break;
            }
         }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox1DblClick(TObject *Sender)
{
   if (ListBox1->ItemIndex>=0)
   {
      ListBox2->Items->Add(ListBox1->Items->Strings[ListBox1->ItemIndex]);
      ListBox1->Items->Delete(ListBox1->ItemIndex);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox2DblClick(TObject *Sender)
{
   if (ListBox2->ItemIndex>=0)
   {
      ListBox1->Items->Add(ListBox2->Items->Strings[ListBox2->ItemIndex]);
      ListBox2->Items->Delete(ListBox2->ItemIndex);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::FormShow(TObject *Sender)
{
   LoadPublics();
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ConventionalClick(TObject *Sender)
{
   if (Conventional->Checked)
   {
      ListBox1->Clear(); ListBox1->Color = clBtnFace; ListBox1->Enabled = false;
      ListBox2->Clear(); ListBox2->Color = clBtnFace; ListBox2->Enabled = false;
   }
   else
   {
      ListBox1->Color = clWindow; ListBox1->Enabled = true;
      ListBox2->Color = clWindow; ListBox2->Enabled = true;
      LoadPublics();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && !ListBox2->Items->Count && !Conventional->Checked)
   {
      MsgBoxHwnd(Handle,
         AnsiString("You must either select at least one recipient\n")+
         AnsiString("or choose the Conventional Encryption option"),
        "No Recipients Selected",
         MB_OK);
      CanClose = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox2DragOver(TObject *Sender,
  TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
   TListBox *src = dynamic_cast<TListBox*>(Source);
   if (src) Accept=true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox2DragDrop(TObject *Sender,
  TObject *Source, int X, int Y)
{
    TListBox *src = dynamic_cast<TListBox*>(Source);
    if (src)
    {
       ListBox2->Items->Add(src->Items->Strings[src->ItemIndex]);
       src->Items->Delete(src->ItemIndex);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox1DragDrop(TObject *Sender,
  TObject *Source, int X, int Y)
{
    TListBox *src = dynamic_cast<TListBox*>(Source);
    if (src)
    {
       ListBox1->Items->Add(src->Items->Strings[src->ItemIndex]);
       src->Items->Delete(src->ItemIndex);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox1DragOver(TObject *Sender,
  TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
   TListBox *src = dynamic_cast<TListBox*>(Source);
   if (src) Accept = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::FormDestroy(TObject *Sender)
{
   delete To;
}
//---------------------------------------------------------------------------
