//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "RunConsole.h"
//#include "global.h"
#pragma resource "*.dfm"
TConsoleForm *ConsoleForm;
//---------------------------------------------------------------------------
void __fastcall RunConsoleAppRelease(AnsiString cmdline)
{
   ConsoleForm = new TConsoleForm(Application->MainForm);
   ConsoleForm->RunConsoleApp(cmdline);
}
//---------------------------------------------------------------------------
__fastcall TConsoleForm::TConsoleForm(TComponent* Owner)
  : TForm(Owner)
{
   Display->Align = alClient;
   Display->Clear();
   working = false;
}
//---------------------------------------------------------------------------
// used by RunConsoleApp {below}
bool __fastcall TConsoleForm::readfile(HANDLE hReadPipe)
{
   static char buf[1024];
   static AnsiString incomingline;
   unsigned long len,bufsize = sizeof(buf)-1;
   ReadFile(hReadPipe,buf,bufsize,&len, NULL);
   if (len>1)
   {
      for (unsigned i=0; i<len; i++)
      {
         if (buf[i]!='\0' && buf[i]!='\n' && buf[i]!='\r')
            incomingline += String(buf[i]);
         if (buf[i]=='\n')
         {
            Display->Lines->Add(incomingline);
            incomingline.SetLength(0);
         }
      }
   }
   if (len<bufsize) return false;
   return true;
}
//---------------------------------------------------------------------------
/*void __fastcall TConsoleApp::Run()
{
   STARTUPINFO sui;
   PROCESS_INFORMATION pi;
   SECURITY_ATTRIBUTES sa;
   HANDLE hReadPipe, hWritePipe;
   // setup the stdout
   // first create the sec attrib
   sa.nLength = sizeof (SECURITY_ATTRIBUTES);
   sa.lpSecurityDescriptor = NULL;
   sa.bInheritHandle = true;
   // create pipe handles
   CreatePipe(&hReadPipe, &hWritePipe, &sa, 2500000);
   if (hReadPipe == INVALID_HANDLE_VALUE || hWritePipe == INVALID_HANDLE_VALUE)
   {
      MessageBox(NULL,"Not a valid Handle for STDOUT",NULL,MB_OK|MB_ICONEXCLAMATION);
      return;
   }
   // setup the start up info
   memset(&sui, 0, sizeof(STARTUPINFO));
   sui.cb = sizeof (STARTUPINFO);
   sui.lpReserved = NULL;
   sui.lpDesktop = NULL;
   sui.lpTitle = NULL;
   sui.lpReserved2 = NULL;
   sui.cbReserved2 = 0;
   sui.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
   sui.wShowWindow = SW_SHOWNORMAL;
   sui.hStdOutput = hWritePipe;
   sui.hStdError = hWritePipe;
   if (!CreateProcess (NULL,
      strCmdLine.c_str(),   	// pointer to command line string
      NULL, 		// pointer to process security attributes, we don't need to inherit the handle
      NULL, 		// pointer to thread security attributes
      true,  		// handle inheritance flag
      0,  		   // creation flags
      NULL, 		// pointer to new environment block
      NULL, 		// pointer to current directory name
     &sui,   		// pointer to STARTUPINFO
     &pi 			// pointer to PROCESS_INFORMATION
   ))
   {
      MessageBox(NULL,"Could not create process", NULL, MB_OK | MB_ICONEXCLAMATION);
      return;
   }
   CloseHandle(pi.hThread);

   DWORD bt;
   int ms=1000;
   timeout=false;
   time_t marktime=time(NULL);
   while (time(NULL)<marktime+30)
   {
      Application->ProcessMessages();
      // if this wait fails go straight to errorstr
      if ((exitwait=WaitForSingleObject(pi.hProcess,ms))!=WAIT_FAILED)
      {
         Application->ProcessMessages();
         while (PeekNamedPipe(hReadPipe,NULL,NULL,NULL,&bt,NULL) && bt)
         {
            Application->ProcessMessages();
            readfile(hReadPipe);
         }
         marktime = time(NULL);
      }
      if (exitwait==WAIT_FAILED || !(exitproc=GetExitCodeProcess(pi.hProcess,&exitcode)))
         errorstr=GetLastErrorStr();
      if (!errorstr.IsEmpty() || exitwait!=WAIT_TIMEOUT) break;
   }
   timeout=time(NULL)>=marktime+30;
   return;
}
*/
//---------------------------------------------------------------------------
void __fastcall TConsoleForm::RunConsoleApp(const AnsiString &strCmdLine)
{
   Caption = strCmdLine;
   Show();

   working = true;
   STARTUPINFO sui;
   PROCESS_INFORMATION pi;
   SECURITY_ATTRIBUTES sa;
   HANDLE hReadPipe, hWritePipe;
   // setup the stdout
   // first create the sec attrib
   sa.nLength = sizeof (SECURITY_ATTRIBUTES);
   sa.lpSecurityDescriptor = NULL;
   sa.bInheritHandle = true;
   // create pipe handles
   CreatePipe(&hReadPipe, &hWritePipe, &sa, 2500000);
   if (hReadPipe == INVALID_HANDLE_VALUE || hWritePipe == INVALID_HANDLE_VALUE)
   {
      MessageBox(Handle,"Not a valid Handle for STDOUT",NULL,MB_OK|MB_ICONEXCLAMATION);
      working = false;
      return;
   }
   // setup the start up info
   memset(&sui, 0, sizeof(STARTUPINFO));
   sui.cb = sizeof (STARTUPINFO);
   sui.lpReserved = NULL;
   sui.lpDesktop = NULL;
   sui.lpTitle = NULL;
   sui.lpReserved2 = NULL;
   sui.cbReserved2 = 0;
   sui.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
   sui.wShowWindow = SW_HIDE;
   sui.hStdOutput = hWritePipe;
   //sui.hStdError = hWritePipe;
   if (!CreateProcess (NULL,
      strCmdLine.c_str(),   	// pointer to command line string
      NULL, 		// pointer to process security attributes, we don't need to inherit the handle
      NULL, 		// pointer to thread security attributes
      true,  		// handle inheritance flag
      0,  		   // creation flags
      NULL, 		// pointer to new environment block
      NULL, 		// pointer to current directory name
     &sui,   		// pointer to STARTUPINFO
     &pi 			// pointer to PROCESS_INFORMATION
   ))
   {
      MessageBox(Handle,"Could not create process", NULL, MB_OK | MB_ICONEXCLAMATION);
      working = false;
      return;
   }
   CloseHandle(pi.hThread);

   int ms=100;
   int done=0;
   DWORD br,bt,bl;
   while (done<30000)
   {
      if (!WaitForSingleObject(pi.hProcess,ms)) break;
      while (PeekNamedPipe(hReadPipe,NULL,NULL,&br,&bt,&bl) && !bt)
         Application->ProcessMessages();
      readfile(hReadPipe);
      done += ms;
   }
   for (int i=0; i<8; i++) Application->ProcessMessages();
   while (PeekNamedPipe(hReadPipe,NULL,NULL,&br,&bt,&bl) && bt)
   {
      //Display->Lines->Add(String((int)b)+"  "+String((int)br)+"  "+String((int)bt)+"  "+String((int)bl));
      readfile(hReadPipe);
   }
   //Display->Lines->Add(String((int)b)+"  "+String((int)br)+"  "+String((int)bt)+"  "+String((int)bl));
   Display->Lines->Add("\n~~");
   MessageBeep(MB_OK);
   working = false;

   return;
}
//---------------------------------------------------------------------------
void __fastcall TConsoleForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (working)
   {
      MessageBeep(MB_OK);
      CanClose = false;
   }
}
//---------------------------------------------------------------------------
